题目名称:Prime Path
题目链接:http://poj.org/problem?id=3126
Description
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
1733
3733
3739
3779
8779
8179
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3 1033 8179 1373 8017 1033 1033
Sample Output
6 7 0
题意:从一个素数变成另一个素数,每次只能改变其中的一位,而且改变后的值得是素数,求到达的最短次数
代码如下:
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
#include<cmath>
#include<queue>
using namespace std;
struct Node
{
string c; //表示数字
int sum; //表示步数
Node(string c,int sum)
{
this->c=c;
this->sum=sum;
}
};
string a,b;
int vis[10000];
bool primer[10000];
queue<Node> q;
void bfs()
{
while(!q.empty())
q.pop();
q.push(Node(a,0));
if(a==b)
{
cout<<'0'<<endl;
return ;
}
while(!q.empty())
{
Node now=q.front();
q.pop();
for(int i=0;i<10;i++)
{
for(int j=0;j<4;j++)
{
string tmp=now.c;
tmp[j]=i+'0';
int num=(tmp[0]-'0')*1000+(tmp[1]-'0')*100+(tmp[2]-'0')*10+tmp[3]-'0';
if(!vis[num]&&primer[num])
{
vis[num]=true;
q.push(Node(tmp,now.sum+1));
}
if(tmp==b)
{
cout<<now.sum+1<<endl;
return ;
}
}
}
}
}
int main()
{
int n;
memset(primer,true,sizeof(primer));
for(int i=2;i<=sqrt(10000+0.5);i++) //素数筛法
{
if(primer[i])
for(int j=i*i;j<=10000;j+=i)
primer[j]=false;
}
for(int i=0;i<1000;i++)
primer[i]=false;
while(cin>>n)
{
for(int i=0;i<n;i++)
{
cin>>a>>b;
memset(vis,0,sizeof(vis));
bfs();
}
}
return 0;
}